Index: drivers/scsi/qla1280.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/scsi/qla1280.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/scsi/qla1280.c	22 Jul 2004 19:50:06 -0000	1.1
+++ drivers/scsi/qla1280.c	4 Aug 2004 01:29:36 -0000	1.2
@@ -4167,302 +3846,253 @@
  * Returns:
  *      0 = success, was able to issue command.
  */
-STATIC uint8_t
-qla1280_32bit_start_scsi(scsi_qla_host_t *ha, srb_t *sp)
+static int
+qla1280_32bit_start_scsi(struct scsi_qla_host *ha, struct srb * sp)
 {
-    device_reg_t    *reg   = ha->iobase;
-    uint8_t         status = 0;
-    Scsi_Cmnd       *cmd = sp->cmd;
-    uint32_t        cnt;
-    cmd_entry_t     *pkt;
-    uint16_t        req_cnt;
-    uint16_t        seg_cnt;
-    struct scatterlist    *sg = (struct scatterlist *) NULL;
-    uint8_t        *data_ptr;
-    uint32_t        *dword_ptr;
-
-    ENTER("qla1280_32bit_start_scsi");
-
-
-    if( qla1280_check_for_dead_scsi_bus(ha, sp) )
-    {
-        return(0);
-    }
-
-    /* Calculate number of entries and segments required. */
-    req_cnt = 1;
-    if (cmd->use_sg)
-    {
-        /*
-        * We must build an SG list in adapter format, as the kernel's SG list
-        * cannot be used directly because of data field size (__alpha__)
-        * differences and the kernel SG list uses virtual addresses where
-        * we need physical addresses.
-        */
-        seg_cnt =  cmd->use_sg;
-        sg = (struct scatterlist *) cmd->request_buffer;
-        /* 
-        * if greater than four sg entries then we need to allocate
-        * continuation entries
-        */
-        if (seg_cnt > 4)
-        {
-            req_cnt += (uint16_t)(seg_cnt - 4) / 7;
-            if ((uint16_t)(seg_cnt - 4) % 7)
-                req_cnt++;
-        }
-        DEBUG(sprintf(debug_buff,"S/G for data transfer -num segs(%d), req blk cnt(%d)\n\r",seg_cnt,req_cnt));
-        DEBUG(qla1280_print(debug_buff));
-    }
-    else if (cmd->request_bufflen)  /* If data transfer. */
-    {
-        DEBUG(printk("Single data transfer (0x%x)\n",cmd->request_bufflen));
-        seg_cnt = 1;
-    }
-    else
-    {
-        DEBUG(printk("No data transfer \n"));
-        seg_cnt = 0;
-    }
-
-    /* Acquire ring specific lock */
-    QLA1280_RING_LOCK(ha);
-
-    if ((uint16_t)(req_cnt + 2) >= ha->req_q_cnt)
-    {
-        /* Calculate number of free request entries. */
-        cnt = RD_REG_WORD(&reg->mailbox4);
-        if (ha->req_ring_index < cnt)
-            ha->req_q_cnt = cnt - ha->req_ring_index;
-        else
-            ha->req_q_cnt = REQUEST_ENTRY_CNT - (ha->req_ring_index - cnt);
-    }
-
-    DEBUG(sprintf(debug_buff,"Number of free entries = (%d)\n\r",ha->req_q_cnt));
-    DEBUG(qla1280_print(debug_buff));
-    /* If room for request in request ring. */
-    if ((uint16_t)(req_cnt + 2) < ha->req_q_cnt)
-    {
-        /* Check for empty slot in outstanding command list. */
-        for (cnt = 1; cnt < MAX_OUTSTANDING_COMMANDS &&
-            (ha->outstanding_cmds[cnt] != 0); cnt++)
-            ;
-
-        if (cnt < MAX_OUTSTANDING_COMMANDS)
-        {
-            CMD_HANDLE(sp->cmd) = (unsigned char *)(unsigned long)cnt;
-            ha->outstanding_cmds[cnt] = sp;
-            ha->req_q_cnt -= req_cnt;
-
-            /*
-            * Build command packet.
-            */
-            pkt = (cmd_entry_t *)ha->request_ring_ptr;
-
-            pkt->entry_type = COMMAND_TYPE;
-            pkt->entry_count = (uint8_t)req_cnt;
-            pkt->sys_define = (uint8_t)ha->req_ring_index;
-            pkt->handle = (uint32_t)cnt;
-
-            /* Zero out remaining portion of packet. */
-            dword_ptr = (uint32_t *)pkt + 2;
-            for (cnt = 2; cnt < REQUEST_ENTRY_SIZE/4; cnt++)
-                *dword_ptr++ = 0;
-
-            /* Set ISP command timeout. */
-            pkt->timeout = (uint16_t)30;
-
-            /* Set device target ID and LUN */
-            pkt->lun = SCSI_LUN_32(cmd);
-            pkt->target = SCSI_BUS_32(cmd) ?
-                    (SCSI_TCN_32(cmd) | BIT_7) : SCSI_TCN_32(cmd);
-
-            /* Enable simple tag queuing if device supports it. */
-            if (cmd->device->tagged_queue )
-                pkt->control_flags |= BIT_3;
-
-            /* Load SCSI command packet. */
-            pkt->cdb_len = (uint16_t)CMD_CDBLEN(cmd);
-            data_ptr = (uint8_t *) &(CMD_CDBP(cmd));
-            for (cnt = 0; cnt < pkt->cdb_len; cnt++)
-                pkt->scsi_cdb[cnt] = *data_ptr++;
-            DEBUG(printk("Build packet for command[0]=0x%x\n",pkt->scsi_cdb[0]));
-            /*
-            * Load data segments.
-            */
-            if (seg_cnt)
-            {
-                DEBUG(printk("loading data segments..\n"));
-                /* Set transfer direction (READ and WRITE) */
-                /* Linux doesn't tell us                   */
-
-                /*
-                * 3/10 dg - Normally, we should need this check with our F/W
-                * but because of a small issue with it we do.
-                *
-                * For block devices, cmd->request.cmd has the operation 
-                * For character devices, this isn't always set properly, so
-                * we need to check data_cmnd[0].  This catches the conditions
-                * for st.c, but not sg. Generic commands are pass down to us.
-                */
-                if ( (cmd->data_cmnd[0] == WRITE_6) )
-                    pkt->control_flags |= BIT_6;
-                else
-                    pkt->control_flags |= (BIT_5|BIT_6);
-                    
-                sp->dir = pkt->control_flags & (BIT_5|BIT_6);
-
-                /* Set total data segment count. */
-                pkt->dseg_count = seg_cnt;
-
-                /* Setup packet address segment pointer. */
-                dword_ptr = (uint32_t *)&pkt->dseg_0_address;
-
-                if (cmd->use_sg)     /* If scatter gather */
-                {
-                    DEBUG(qla1280_print("Building S/G data segments..\n\r"));
-                    DEBUG(qla1280_dump_buffer((caddr_t)sg, 4*16 ));
-                    /* Load command entry data segments. */
-                    for (cnt = 0; cnt < 4 && seg_cnt; cnt++, seg_cnt--)
-                    {
-                        *dword_ptr++ = (uint32_t) cpu_to_le32(VIRT_TO_BUS(sg->address));
-                        *dword_ptr++ = sg->length;
-                        DEBUG(sprintf(debug_buff,"SG Segment ap=0x%p, len=0x%x\n\r",sg->address,sg->length));
-                        DEBUG(qla1280_print(debug_buff));
-                        sg++;
-                    }
-                    /*
-                    * Build continuation packets.
-                    */
-                    while (seg_cnt > 0)
-                    {
-                        /* Adjust ring index. */
-                        ha->req_ring_index++;
-                        if (ha->req_ring_index == REQUEST_ENTRY_CNT)
-                        {
-                            ha->req_ring_index = 0;
-                            ha->request_ring_ptr = ha->request_ring;
-                        }
-                        else
-                            ha->request_ring_ptr++;
-
-                        pkt = (cmd_entry_t *)ha->request_ring_ptr;
-
-                        /* Zero out packet. */
-                        dword_ptr = (uint32_t *)pkt;
-                        for (cnt = 0;cnt < REQUEST_ENTRY_SIZE/4; cnt++)
-                            *dword_ptr++ = 0;
-
-                        /* Load packet defaults. */
-                        ((cont_entry_t *)pkt)->entry_type =
-                                CONTINUE_TYPE;
-                        ((cont_entry_t *)pkt)->entry_count = 1;
-
-                        ((cont_entry_t *)pkt)->sys_define = (uint8_t)
-                                ha->req_ring_index;
-
-                        /* Setup packet address segment pointer. */
-                        dword_ptr = (uint32_t *)
-                                &((cont_entry_t *)pkt)->dseg_0_address;
-
-                        /* Load continuation entry data segments. */
-                        for (cnt = 0; cnt < 7 && seg_cnt; cnt++, seg_cnt--)
-                        {
-                            *dword_ptr++ = (u_int) cpu_to_le32(VIRT_TO_BUS(sg->address));
-                            *dword_ptr++ = sg->length;
-                            sg++;
-                        }
-#ifdef QL_DEBUG_LEVEL_5
-                        qla1280_print(
-                                "qla1280_32bit_start_scsi: continuation packet data - scsi(");
-                        qla1280_output_number((uint32_t)SCSI_BUS_32(cmd), 10);
-                        qla1280_print(":");
-                        qla1280_output_number((uint32_t)SCSI_TCN_32(cmd), 10);
-                        qla1280_print(":");
-                        qla1280_output_number((uint32_t)SCSI_LUN_32(cmd), 10);
-                        qla1280_print(")\n\r");
-                        qla1280_dump_buffer((caddr_t)pkt, REQUEST_ENTRY_SIZE);
-#endif
-                    }
-                }
-                else                    /* No scatter gather data transfer */
-                {
-                    *dword_ptr++ = (uint32_t) cpu_to_le32(VIRT_TO_BUS(cmd->request_buffer));
-                    *dword_ptr = (uint32_t) cmd->request_bufflen;
-                    DEBUG(printk("Single Segment ap=0x%p, len=0x%x\n",cmd->request_buffer,cmd->request_bufflen));
-                }
-            }
-            else                            /* No data transfer */
-            {
-                *dword_ptr++ = (uint32_t) 0;
-                *dword_ptr = (uint32_t)  0;
-#ifdef QL_DEBUG_LEVEL_5
-                qla1280_print(
-                        "qla1280_32bit_start_scsi: No data, command packet data - ");
-                qla1280_print("\n\r");
-                qla1280_dump_buffer((caddr_t)pkt, REQUEST_ENTRY_SIZE);
-#endif
-            }
-#ifdef QL_DEBUG_LEVEL_5
-            qla1280_print("qla1280_32bit_start_scsi: First IOCB block:\n\r");
-            qla1280_dump_buffer((caddr_t)ha->request_ring_ptr, REQUEST_ENTRY_SIZE);
-#endif
-            /* Adjust ring index. */
-            ha->req_ring_index++;
-            if (ha->req_ring_index == REQUEST_ENTRY_CNT)
-            {
-                ha->req_ring_index = 0;
-                ha->request_ring_ptr = ha->request_ring;
-            }
-            else
-                ha->request_ring_ptr++;
-
-            /* Set chip new ring index. */
-            DEBUG(qla1280_print("qla1280_32bit_start_scsi: Wakeup RISC for pending command\n\r"));
-            ha->qthreads--;
-            sp->u_start = jiffies;
-            sp->flags |= SRB_SENT;
-            ha->actthreads++;
-            /* qla1280_output_number((uint32_t)ha->actthreads++, 16); */
-            WRT_REG_WORD(&reg->mailbox4, ha->req_ring_index);
-        }
-        else
-        {
-            status = 1;
-#ifdef QL_DEBUG_LEVEL_2
-            qla1280_print(
-                    "qla1280_32bit_start_scsi: NO ROOM IN OUTSTANDING ARRAY\n\r");
-            qla1280_print(" req_q_cnt=");
-            qla1280_output_number((uint32_t)ha->req_q_cnt, 16);
-            qla1280_print("\n\r");
-#endif
-        }
-    }
-    else
-    {
-        status = 1;
-#ifdef QL_DEBUG_LEVEL_2
-        /*  qla1280_print("qla1280_32bit_start_scsi: in-ptr=");
-        qla1280_output_number((uint32_t)ha->req_ring_index, 16);
-        qla1280_print(" req_q_cnt=");
-        qla1280_output_number((uint32_t)ha->req_q_cnt, 16);
-        qla1280_print(" req_cnt=");
-        qla1280_output_number((uint32_t)req_cnt, 16);
-        qla1280_print("\n\r"); */
-#endif
-    }
-
-    /* Release ring specific lock */
-    QLA1280_RING_UNLOCK(ha);
-
-#if defined(QL_DEBUG_LEVEL_2) || defined(QL_DEBUG_LEVEL_3)
-    /* if (status)
-    qla1280_print("qla1280_32bit_start_scsi: **** FAILED ****\n\r"); */
-#endif
-#ifdef QL_DEBUG_LEVEL_3
-            LEAVE("qla1280_32bit_start_scsi");
-#endif
-    return(status);
+	struct device_reg *reg = ha->iobase;
+	Scsi_Cmnd *cmd = sp->cmd;
+	struct cmd_entry *pkt;
+	struct scatterlist *sg = NULL;
+	uint32_t *dword_ptr;
+	int status = 0;
+	int cnt;
+	int req_cnt;
+	uint16_t seg_cnt;
+	dma_addr_t dma_handle;
+
+	ENTER("qla1280_32bit_start_scsi");
+
+	dprintk(1, "32bit_start: cmd=%p sp=%p CDB=%x\n", cmd, sp,
+		cmd->cmnd[0]);
+
+	/* Calculate number of entries and segments required. */
+	req_cnt = 1;
+	if (cmd->use_sg) {
+		/*
+		 * We must build an SG list in adapter format, as the kernel's
+		 * SG list cannot be used directly because of data field size
+		 * (__alpha__) differences and the kernel SG list uses virtual
+		 * addresses where we need physical addresses.
+		 */
+		sg = (struct scatterlist *) cmd->request_buffer;
+		seg_cnt = pci_map_sg(ha->pdev, sg, cmd->use_sg,
+				     scsi_to_pci_dma_dir(cmd->sc_data_direction));
+
+		/*
+		 * if greater than four sg entries then we need to allocate
+		 * continuation entries
+		 */
+		if (seg_cnt > 4) {
+			req_cnt += (seg_cnt - 4) / 7;
+			if ((seg_cnt - 4) % 7)
+				req_cnt++;
+		}
+		dprintk(3, "S/G Transfer cmd=%p seg_cnt=0x%x, req_cnt=%x\n",
+			cmd, seg_cnt, req_cnt);
+	} else if (cmd->request_bufflen) {	/* If data transfer. */
+		dprintk(3, "No S/G transfer t=%x cmd=%p len=%x CDB=%x\n",
+			SCSI_TCN_32(cmd), cmd, cmd->request_bufflen,
+			cmd->cmnd[0]);
+		seg_cnt = 1;
+	} else {
+		/* dprintk(1, "No data transfer \n"); */
+		seg_cnt = 0;
+	}
+
+	if ((req_cnt + 2) >= ha->req_q_cnt) {
+		/* Calculate number of free request entries. */
+		cnt = RD_REG_WORD(&reg->mailbox4);
+		if (ha->req_ring_index < cnt)
+			ha->req_q_cnt = cnt - ha->req_ring_index;
+		else
+			ha->req_q_cnt =
+				REQUEST_ENTRY_CNT - (ha->req_ring_index - cnt);
+	}
+
+	dprintk(3, "Number of free entries=(%d) seg_cnt=0x%x\n",
+		ha->req_q_cnt, seg_cnt);
+	/* If room for request in request ring. */
+	if ((req_cnt + 2) >= ha->req_q_cnt) {
+		status = 1;
+		dprintk(2, "qla1280_32bit_start_scsi: in-ptr=0x%x, "
+			"req_q_cnt=0x%x, req_cnt=0x%x", ha->req_ring_index,
+			ha->req_q_cnt, req_cnt);
+		goto out;
+	}
+
+	/* Check for empty slot in outstanding command list. */
+	for (cnt = 0; cnt < MAX_OUTSTANDING_COMMANDS &&
+		     (ha->outstanding_cmds[cnt] != 0); cnt++) ;
+
+	if (cnt >= MAX_OUTSTANDING_COMMANDS) {
+		status = 1;
+		dprintk(2, "qla1280_32bit_start_scsi: NO ROOM IN OUTSTANDING "
+			"ARRAY, req_q_cnt=0x%x\n", ha->req_q_cnt);
+		goto out;
+	}
+
+	CMD_HANDLE(sp->cmd) = (unsigned char *) (unsigned long)(cnt + 1);
+	ha->outstanding_cmds[cnt] = sp;
+	ha->req_q_cnt -= req_cnt;
+
+	/*
+	 * Build command packet.
+	 */
+	pkt = (struct cmd_entry *) ha->request_ring_ptr;
+
+	pkt->entry_type = COMMAND_TYPE;
+	pkt->entry_count = (uint8_t) req_cnt;
+	pkt->sys_define = (uint8_t) ha->req_ring_index;
+	pkt->entry_status = 0;
+	pkt->handle = cpu_to_le32(cnt);
+
+	/* Zero out remaining portion of packet. */
+	memset(((char *)pkt + 8), 0, (REQUEST_ENTRY_SIZE - 8));
+
+	/* Set ISP command timeout. */
+	pkt->timeout = cpu_to_le16(30);
+
+	/* Set device target ID and LUN */
+	pkt->lun = SCSI_LUN_32(cmd);
+	pkt->target = SCSI_BUS_32(cmd) ?
+		(SCSI_TCN_32(cmd) | BIT_7) : SCSI_TCN_32(cmd);
+
+	/* Enable simple tag queuing if device supports it. */
+	if (DEV_SIMPLE_TAGS(cmd->device))
+		pkt->control_flags |= cpu_to_le16(BIT_3);
+
+	/* Load SCSI command packet. */
+	pkt->cdb_len = cpu_to_le16(CMD_CDBLEN(cmd));
+	memcpy(pkt->scsi_cdb, &(CMD_CDBP(cmd)), CMD_CDBLEN(cmd));
+
+	/*dprintk(1, "Build packet for command[0]=0x%x\n",pkt->scsi_cdb[0]); */
+	/* Set transfer direction. */
+	sp->dir = qla1280_data_direction(cmd);
+	pkt->control_flags |= cpu_to_le16(sp->dir);
+
+	/* Set total data segment count. */
+	pkt->dseg_count = cpu_to_le16(seg_cnt);
+
+	/*
+	 * Load data segments.
+	 */
+	if (seg_cnt) {
+		/* Setup packet address segment pointer. */
+		dword_ptr = &pkt->dseg_0_address;
+
+		if (cmd->use_sg) {	/* If scatter gather */
+			dprintk(3, "Building S/G data segments..\n");
+			qla1280_dump_buffer(1, (char *)sg, 4 * 16);
+
+			/* Load command entry data segments. */
+			for (cnt = 0; cnt < 4 && seg_cnt; cnt++, seg_cnt--) {
+				*dword_ptr++ =
+					cpu_to_le32(pci_dma_lo32(sg_dma_address(sg)));
+				*dword_ptr++ =
+					cpu_to_le32(sg_dma_len(sg));
+				dprintk(3, "S/G Segment phys_addr=0x%lx, len=0x%x\n",
+					(pci_dma_lo32(sg_dma_address(sg))),
+					(sg_dma_len(sg)));
+				sg++;
+			}
+			/*
+			 * Build continuation packets.
+			 */
+			dprintk(3, "S/G Building Continuation"
+				"...seg_cnt=0x%x remains\n", seg_cnt);
+			while (seg_cnt > 0) {
+				/* Adjust ring index. */
+				ha->req_ring_index++;
+				if (ha->req_ring_index == REQUEST_ENTRY_CNT) {
+					ha->req_ring_index = 0;
+					ha->request_ring_ptr =
+						ha->request_ring;
+				} else
+					ha->request_ring_ptr++;
+
+				pkt = (struct cmd_entry *)ha->request_ring_ptr;
+
+				/* Zero out packet. */
+				memset(pkt, 0, REQUEST_ENTRY_SIZE);
+
+				/* Load packet defaults. */
+				((struct cont_entry *) pkt)->
+					entry_type = CONTINUE_TYPE;
+				((struct cont_entry *) pkt)->entry_count = 1;
+
+				((struct cont_entry *) pkt)->sys_define =
+					(uint8_t) ha->req_ring_index;
+
+				/* Setup packet address segment pointer. */
+				dword_ptr =
+					&((struct cont_entry *) pkt)->dseg_0_address;
+
+				/* Load continuation entry data segments. */
+				for (cnt = 0; cnt < 7 && seg_cnt;
+				     cnt++, seg_cnt--) {
+					*dword_ptr++ =
+						cpu_to_le32(pci_dma_lo32(sg_dma_address(sg)));
+					*dword_ptr++ =
+						cpu_to_le32(sg_dma_len(sg));
+					dprintk(1,
+						"S/G Segment Cont. phys_addr=0x%x, "
+						"len=0x%x\n",
+						cpu_to_le32(pci_dma_lo32(sg_dma_address(sg))),
+						cpu_to_le32(sg_dma_len(sg)));
+					sg++;
+				}
+				dprintk(5, "qla1280_32bit_start_scsi: "
+					"continuation packet data - "
+					"scsi(%i:%i:%i)\n", SCSI_BUS_32(cmd),
+					SCSI_TCN_32(cmd), SCSI_LUN_32(cmd));
+				qla1280_dump_buffer(5, (char *)pkt,
+						    REQUEST_ENTRY_SIZE);
+			}
+		} else {	/* No S/G data transfer */
+			struct page *page = virt_to_page(cmd->request_buffer);
+			unsigned long off = (unsigned long)cmd->request_buffer & ~PAGE_MASK;
+			dma_handle = pci_map_page(ha->pdev, page, off,
+						  cmd->request_bufflen,
+						  scsi_to_pci_dma_dir(cmd->sc_data_direction));
+			sp->saved_dma_handle = dma_handle;
+
+			*dword_ptr++ = cpu_to_le32(pci_dma_lo32(dma_handle));
+			*dword_ptr = cpu_to_le32(cmd->request_bufflen);
+		}
+	} else {	/* No data transfer at all */
+		dword_ptr = (uint32_t *)(pkt + 1);
+		*dword_ptr++ = 0;
+		*dword_ptr = 0;
+		dprintk(5, "qla1280_32bit_start_scsi: No data, command "
+			"packet data - \n");
+		qla1280_dump_buffer(5, (char *)pkt, REQUEST_ENTRY_SIZE);
+	}
+	dprintk(5, "qla1280_32bit_start_scsi: First IOCB block:\n");
+	qla1280_dump_buffer(5, (char *)ha->request_ring_ptr,
+			    REQUEST_ENTRY_SIZE);
+
+	/* Adjust ring index. */
+	ha->req_ring_index++;
+	if (ha->req_ring_index == REQUEST_ENTRY_CNT) {
+		ha->req_ring_index = 0;
+		ha->request_ring_ptr = ha->request_ring;
+	} else
+		ha->request_ring_ptr++;
+
+	/* Set chip new ring index. */
+	dprintk(2, "qla1280_32bit_start_scsi: Wakeup RISC "
+		"for pending command\n");
+	sp->flags |= SRB_SENT;
+	ha->actthreads++;
+	WRT_REG_WORD(&reg->mailbox4, ha->req_ring_index);
+
+out:
+	if (status)
+		dprintk(2, "qla1280_32bit_start_scsi: **** FAILED ****\n");
+
+	LEAVE("qla1280_32bit_start_scsi");
+
+	return status;
 }
 
 /*
